/*
 *  Copyright (C) 1993  Robert Davis
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of Version 2, or any later version, of 
 *  the GNU General Public License as published by the Free Software 
 *  Foundation.
 */

/* $Id: DataPane.h,v 1.7 1993/05/04 16:21:38 davis Exp $ */

#import "Pane.h"

@class DataOptionsPanel, List;

@interface DataPane:Pane
{
    BOOL didSwap;		/* True if we just became the current pane */

    List 	*functionObjects;
    id  	functionsScrollView;
    id  	functionsMatrix;
    id  	functionsForm;

    id  	deleteFunctionButton;
    id  	modifyFunctionButton;
    id		inspectButton;

    id  	dummyFormCellX;
    id  	dummyFormCellY;

    DataOptionsPanel *optionsPanel;
}

- init;
- free;

- selectControl:sender;			/** Overridden from Pane	**/
- (BOOL)updateStatus:aStatus doc:aDoc;
- (BOOL)forceUpdateStatus:aStatus doc:aDoc;
- didSwapIn:sender;
- didSwapOut:sender;

- doSetDummy:sender;			/** Target/Action		**/
- findDataFile:sender;

- selectFunction:sender;
- deleteSelectedFunctions:sender;
- modifySelectedFunction:sender;
- addFunction:sender;
- functionsMatrix;

- addDataFile:(const char *)aPath;

- showOptionsPanel:sender;		/** Options Panel		**/

@end
