/*
 *  Copyright (C) 1993  Robert Davis
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of Version 2, or any later version, of 
 *  the GNU General Public License as published by the Free Software 
 *  Foundation.
 */

/* $Id: EditMatrix.h,v 1.4 1993/05/04 16:21:47 davis Exp $ */

#import <appkit/Matrix.h>

@class TextFieldCell;

@interface EditMatrix:Matrix
{
    BOOL	editableCells;	/* Edit cells with double click?	*/
    TextFieldCell *editingCell;	/* The cell being edited, if any	*/

@private
    int		selectedCount;
}

- initFrame:(const NXRect *)frameRect;

- setEditableCells:(BOOL)aCond;
- (BOOL)editableCells;

- mouseDown:(NXEvent *)theEvent;
- textDidEnd:textObject endChar:(short unsigned)whyEnd;

- (BOOL)multipleCellsSelected;
- selectedCell;		/* WARNING: This returns nil if multiple selection */

@end
