/*
 *  Copyright (C) 1993  Robert Davis
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of Version 2, or any later version, of 
 *  the GNU General Public License as published by the Free Software 
 *  Foundation.
 */

/* $Id: StatusContour.h,v 1.6 1993/05/04 16:22:48 davis Exp $ */

#import "Status.h"

#define CONTOUR_NONE		0	/* Where to place contour maps */
#define CONTOUR_BASE		1
#define CONTOUR_SRF		2
#define CONTOUR_BOTH		3

#define CONTOUR_KIND_LINEAR     0	/* Contour type */
#define CONTOUR_KIND_CUBIC_SPL  1
#define CONTOUR_KIND_BSPLINE    2

#define LEVELS_AUTO		0	/* How contour levels are set */
#define LEVELS_INCREMENTAL	1
#define LEVELS_DISCRETE		2


@interface Status (Contour)

- initContour;
- freeContour;

- resetCurrentContour;
- applyCurrentContour;
- grabCurrentContour;

- setContourBase:(BOOL) cond;
- (BOOL) contourBase;
- setContourSurface:(BOOL) cond;
- (BOOL) contourSurface;

- setContourKind:(int) anInt;
- (int) contourKind;
- setContourPoints:(int) anInt;
- (int) contourPoints;
- setContourOrder:(int) anInt;
- (int) contourOrder;

- setContourLevels:(int) anInt;
- (int) contourLevels;
- setContourLevelsKind:(int) anInt;
- (int) contourLevelsKind;

- setContourLevelsStart:(double)aDouble;	/* Levels Series */
- (double)contourLevelsStart;
- setContourLevelsIncr:(double)aDouble;
- (double)contourLevelsIncr;
- setContourLevelsEnd:(double)aDouble;
- (double)contourLevelsEnd;

- (DoubleValueSortedList *) levelDefs;		/* Levels Defined */

- setContourInKey:(BOOL) cond;
- (BOOL)contourInKey;

@end
