/*
 *  Copyright (C) 1993  Robert Davis
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of Version 2, or any later version, of 
 *  the GNU General Public License as published by the Free Software 
 *  Foundation.
 */

/* $Id: StatusTics.h,v 1.4 1993/05/04 16:22:51 davis Exp $ */

#import "Status.h"

#define TIC_COMPUTED		1	/* default; gnuplot calcs them	*/
#define TIC_SERIES		2	/* user-defined series		*/
#define TIC_USER		3	/* user-defined points		*/

@interface Status (Tics)

- initTics;
- freeTics;
- resetCurrentTics;
- applyCurrentTics;
- grabCurrentTics;

- setTicsIn:(BOOL) cond;		/* YES = tics in, NO = tics out */
- (BOOL) ticsIn;
- setTicsCoord:(int)coord isOn:(BOOL)isOn;
- (BOOL) ticsCoord:(int)coord;
- setTicTypeCoord:(int)coord to:(int)anInt;
- (int)ticTypeCoord:(int)coord;
- setTicStartCoord:(int)coord to:(double)aDouble;
- (double)ticStartCoord:(int)coord;
- setTicEndCoord:(int)coord to:(double)aDouble;
- (double)ticEndCoord:(int)coord;
- setTicIncrementCoord:(int)coord to:(double)aDouble;
- (double)ticIncrementCoord:(int)coord;
- (DoubleValueSortedList *)ticDefsCoord:(int)coord;

@end
