/* --------------------------------------------------------------------------

Class:			MHFilterTool
Version:		0.1
File:			MHFilterTool.m				 

Written by:		Thomas Engel
Created:		17.05.1995	(Copyleft)
Last modified:	17.05.1995


Note:	For a detailed description please read the class documentation.

 ------------------------------------------------------------------------- */

#import <MHFilterTool.h>

@implementation MHFilterTool

- image
{
	return [NXImage findImageNamed:"ConsoleScreen"];
}

- (BOOL)canProcess:aFile for:aController
{
	// Remember the controller. By default we handle no filetype.

	processController = aController;
	return NO;
}

- revert:sender
{
	return self;
}

- processInput:aPath forOutput:outPath
{
	return self;
}

- startProcessing:sender
{
	if( processController )
	{
		if( !activeShell )
			activeShell = [processController sharedShell];
	
		if( [processController toolWillStartProcessing:self] == nil )
		{
			NXBeep();
			return nil;
		}
		isProcessing = YES;
		[self processInput:[processController filename]
				forOutput:[processController outputFilename]];
	}
	return self;
}

- stopProcessing:sender
{
	// Only if we really are active..otherwise we might terminate another
	// tools shell !

	if( activeShell &&
		isProcessing )
	{
		[activeShell terminate:self];
		isProcessing = NO;
		[processController toolDidStopProcessing:self];
	}
	return self;
}

- (BOOL)isProcessing
{
	return isProcessing;
}

- willSwapIn
{
	[self revert:self];
	return self;
}

@end